<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output  
	method="xml"
	doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" 
	doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"
	indent="yes" />
	<xsl:template match="/">
		<hr />
		<h2>
			<xsl:value-of select="/root/lang/h2_classes" />
		</h2>
		<hr />
		<div>
			<div style="float:left; margin-right:10px">
				<img>
					<xsl:attribute name="src">
						<xsl:value-of select="/root/class/image" />
					</xsl:attribute>
				</img>
				<table class="no_aligin">
					<tr>
						<td>
							<xsl:value-of select="/root/lang/class" />
						</td>
						<td>
							<xsl:value-of select="/root/class/name" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/class_info" />
						</td>
						<td>
							<xsl:value-of select="/root/class/info" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/hp" />
						</td>
						<td>
							<xsl:value-of select="/root/class/hp" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/speed" />
						</td>
						<td>
							<xsl:value-of select="/root/class/speed" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/grav" />
						</td>
						<td>
							<xsl:value-of select="/root/class/grav" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/kb" />
						</td>
						<td>
							<xsl:value-of select="/root/class/kb" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/infect" />
						</td>
						<td>
							<xsl:value-of select="/root/class/infect" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/kills" />
						</td>
						<td>
							<xsl:value-of select="/root/class/kills" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/death" />
						</td>
						<td>
							<xsl:value-of select="/root/class/death" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/games" />
						</td>
						<td>
							<xsl:value-of select="/root/class/games" />
						</td>
					</tr>
				</table>
			</div>	
			<div>
				<b>
					<xsl:value-of select="/root/lang/best_players" />
				</b>
				<table>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/name" />
						</td>
						<td>
							<xsl:value-of select="/root/lang/infect" />
						</td>
					</tr>
					<xsl:for-each select="/root/players/player">
						<tr>
							<td class="td_left">
								<a>
									<xsl:attribute name="href">
										<xsl:text>index.php?action=player&amp;id=</xsl:text>
										<xsl:value-of select="id_player"/>
									</xsl:attribute>
									<xsl:value-of select="nick" />
								</a>
							</td>
							<td>
								<xsl:value-of select="infect" />
							</td>
						</tr>
					</xsl:for-each>
				</table>
			</div>	
		</div>
		<hr />
	</xsl:template>
</xsl:stylesheet>