<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output  
	method="xml"
	doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" 
	doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"
	indent="yes" />
	<xsl:template match="/">
		<hr />
		<h2>
			<xsl:value-of select="/root/lang/h2_index" />
		</h2>
		<form action="index.php" method="post">
			<label for="search">
				<xsl:value-of select="/root/lang/search" />
			</label>
			<xsl:element name="input">
				<xsl:attribute name="type">
					<xsl:text>text</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="id">
					<xsl:text>search</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="name">
					<xsl:text>search</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="value">
					<xsl:value-of select="/root/search" />
				</xsl:attribute>
			</xsl:element>
			<xsl:element name="input">
				<xsl:attribute name="type">
					<xsl:text>submit</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="value">
					<xsl:value-of select="/root/lang/search" />
				</xsl:attribute>
			</xsl:element>
		</form>
		<hr />
		<xsl:for-each select="/root/pages/page">
			<xsl:choose>
				<xsl:when test="@current=1">
					<b>
						<xsl:value-of select="data" />
					</b>
				</xsl:when>
				<xsl:otherwise>
					<a>
						<xsl:attribute name="href">
							<xsl:text>index.php?page=</xsl:text>
							<xsl:value-of select="href"/>
						</xsl:attribute>
						<xsl:value-of select="data" />
					</a>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>	
		<hr />
		<table>
			<tr>
				<td>
					<a href="index.php?sort=0">
						<xsl:value-of select="/root/lang/rank" />
					</a>	
				</td>
				<td>
					<a href="index.php?sort=1">
						<xsl:value-of select="/root/lang/name" />
					</a>	
				</td>
				<td>
					<a href="index.php?sort=2">
						<xsl:value-of select="/root/lang/total_ammo" />
					</a>
				</td>
				<td>
					<a href="index.php?sort=3">
						<xsl:value-of select="/root/lang/total_damage" />
					</a>
				</td>
				<td>
					<a href="index.php?sort=4">
						<xsl:value-of select="/root/lang/zombiekills" />
					</a>
				</td>
				<td>
					<a href="index.php?sort=5">
						<xsl:value-of select="/root/lang/humankills" />
					</a>
				</td>
				<td>
					<a href="index.php?sort=6">
						<xsl:value-of select="/root/lang/nemkills" />
					</a>
				</td>
				<td>
					<a href="index.php?sort=7">
						<xsl:value-of select="/root/lang/survkills" />
					</a>
				</td>
				<td>
					<a href="index.php?sort=8">
						<xsl:value-of select="/root/lang/suicide" />
					</a>
				</td>
				<td>
					<a href="index.php?sort=9">
						<xsl:value-of select="/root/lang/death" />
					</a>
				</td>
				<td>
					<a href="index.php?sort=10">
						<xsl:value-of select="/root/lang/infected" />
					</a>
				</td>
				<td>
					<a href="index.php?sort=11">
						<xsl:value-of select="/root/lang/online" />
					</a>
				</td>
			</tr>
			<xsl:for-each select="/root/players/player">
				<tr>
					<td>
						<xsl:value-of select="rank" />
					</td>
					<td class="td_left">
						<a>
							<xsl:attribute name="href">
								<xsl:text>index.php?action=player&amp;id=</xsl:text>
								<xsl:value-of select="id"/>
							</xsl:attribute>
							<xsl:value-of select="nick" />
						</a>
					</td>
					<td>
						<xsl:value-of select="total_ammo" />
					</td>
					<td>
						<xsl:value-of select="total_damage" />
					</td>
					<td>
						<xsl:value-of select="zombiekills" />
					</td>
					<td>
						<xsl:value-of select="humankills" />
					</td>
					<td>
						<xsl:value-of select="nemkills" />
					</td>
					<td>
						<xsl:value-of select="survkills" />
					</td>
					<td>
						<xsl:value-of select="suicide" />
					</td>
					<td>
						<xsl:value-of select="death" />
					</td>
					<td>
						<xsl:value-of select="infected" />
					</td>
					<td>
						<xsl:value-of select="online" />
					</td>
				</tr>
			</xsl:for-each>
		</table>
		<hr />
		<xsl:for-each select="/root/pages/page">
			<xsl:choose>
				<xsl:when test="@current=1">
					<b>
						<xsl:value-of select="data" />
					</b>
				</xsl:when>
				<xsl:otherwise>
					<a>
						<xsl:attribute name="href">
							<xsl:text>index.php?page=</xsl:text>
							<xsl:value-of select="href"/>
						</xsl:attribute>
						<xsl:value-of select="data" />
					</a>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>	
	</xsl:template>
</xsl:stylesheet>