<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:import />
	<xsl:output  
	method="xml"
	doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" 
	doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"
	indent="yes" />
	<xsl:template match="/">
		<html>
			<head>
				<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
				<title><xsl:value-of select="/root/title" /></title>
				<link rel="stylesheet" href="templates/style.css" type="text/css">
					<xsl:attribute name="href">
						<xsl:text>
							templates/
						</xsl:text>
						<xsl:value-of select="/root/template" />
						<xsl:text>
							/style.css
						</xsl:text>
					</xsl:attribute>
				</link>
			</head>
			<body>
				<div style="text-align:right">
					<div id="navigation" style="float:left;display:inline">
						<a>
							<xsl:attribute name="href">
								<xsl:value-of select="/root/main_link" />
							</xsl:attribute>
							<xsl:value-of select="/root/lang/index" />
						</a>
						<a href="index.php">
							<xsl:value-of select="/root/lang/players" />
						</a>
						<a href="index.php?action=maps">
							<xsl:value-of select="/root/lang/maps" />
						</a>
						<a href="index.php?action=weapons">
							<xsl:value-of select="/root/lang/weapon" />
						</a>
						<a href="index.php?action=classes">
							<xsl:value-of select="/root/lang/h2_classes" />
						</a>
						<a href="index.php?action=graph">
							<xsl:value-of select="/root/lang/h2_graph" />
						</a>
					</div>	
					<form method="post" id="customForm" style="display:inline">
						<xsl:attribute name="action">
							<xsl:value-of select="/root/request_uri" />
						</xsl:attribute>
						<label for="lang">
							<xsl:value-of select="/root/lang/choose_lang" />
						</label>
						<select id="lang" name="lang" onchange="document.getElementById('customForm').submit();">
							<xsl:for-each select="/root/chooselang/lang">
								<option>
									<xsl:attribute name="value">
										<xsl:value-of select="position()" />
									</xsl:attribute>
									<xsl:if test="@current=1">
										<xsl:attribute name="selected">selected</xsl:attribute>
									</xsl:if>
									<xsl:value-of select="." />
								</option>
							</xsl:for-each>
						</select>
						<label for="template">
							<xsl:value-of select="/root/lang/choose_skin" />
						</label>
						<select id="template" name="template" onchange="document.getElementById('customForm').submit();">
							<xsl:for-each select="/root/templates/template">
								<option>
									<xsl:attribute name="value">
										<xsl:value-of select="position()" />
									</xsl:attribute>
									<xsl:if test="@current=1">
										<xsl:attribute name="selected">selected</xsl:attribute>
									</xsl:if>
									<xsl:value-of select="." />
								</option>
							</xsl:for-each>
						</select>
					</form>
				</div>
				<div id="content">
					<xsl:apply-imports />
				</div>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>