<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output  
	method="xml"
	doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" 
	doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"
	indent="yes" />
	<xsl:template match="/">
		<hr />
		<h2>
			<xsl:value-of select="/root/lang/h2_maps" />
		</h2>
		<form action="index.php?action=maps" method="post">
			<label for="search">
				<xsl:value-of select="/root/lang/search" />
			</label>
			<xsl:element name="input">
				<xsl:attribute name="type">
					<xsl:text>text</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="id">
					<xsl:text>search</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="name">
					<xsl:text>search</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="value">
					<xsl:value-of select="/root/search" />
				</xsl:attribute>
			</xsl:element>
			<xsl:element name="input">
				<xsl:attribute name="type">
					<xsl:text>submit</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="value">
					<xsl:value-of select="/root/lang/search" />
				</xsl:attribute>
			</xsl:element>
		</form>
		<hr />
		<xsl:for-each select="/root/pages/page">
			<xsl:choose>
				<xsl:when test="@current=1">
					<b>
						<xsl:value-of select="data" />
					</b>
				</xsl:when>
				<xsl:otherwise>
					<a>
						<xsl:attribute name="href">
							<xsl:text>index.php?action=maps&amp;page=</xsl:text>
							<xsl:value-of select="href"/>
							<xsl:if test="/root/search">
								<xsl:text>&amp;search=</xsl:text>
								<xsl:value-of select="/root/search" />
							</xsl:if>
						</xsl:attribute>
						<xsl:value-of select="data" />
					</a>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>	
		<hr />
		<table>
			<tr>
				<td colspan="2">
					<a href="index.php?action=maps&amp;sort=0">
						<xsl:value-of select="/root/lang/map" />
					</a>	
				</td>
				<td>
					<a href="index.php?action=maps&amp;sort=1">
						<xsl:value-of select="/root/lang/zombie_win" />
					</a>	
				</td>
				<td>
					<a href="index.php?action=maps&amp;sort=2">
						<xsl:value-of select="/root/lang/human_win" />
					</a>	
				</td>
				<td>
					<a href="index.php?action=maps&amp;sort=3">
						<xsl:value-of select="/root/lang/tie" />
					</a>	
				</td>
				<td>
					<a href="index.php?action=maps&amp;sort=4">
						<xsl:value-of select="/root/lang/games" />
					</a>
				</td>
			</tr>
			<xsl:for-each select="/root/maps/map">
				<tr>
					<td>
						<img class="picks">
							<xsl:attribute name="src">
								<xsl:value-of select="image" />
							</xsl:attribute>
						</img>
					</td>
					<td class="td_left">
						<xsl:value-of select="map" />
					</td>
					<td>
						<xsl:value-of select="zombie_win" />
					</td>
					<td>
						<xsl:value-of select="human_win" />
					</td>
					<td>
						<xsl:value-of select="tie" />
					</td>
					<td>
						<xsl:value-of select="games" />
					</td>
				</tr>
			</xsl:for-each>
		</table>
		<hr />
		<xsl:for-each select="/root/pages/page">
			<xsl:choose>
				<xsl:when test="@current=1">
					<b>
						<xsl:value-of select="data" />
					</b>
				</xsl:when>
				<xsl:otherwise>
					<a>
						<xsl:attribute name="href">
							<xsl:text>index.php?action=maps&amp;page=</xsl:text>
							<xsl:value-of select="href"/>
							<xsl:if test="/root/search">
								<xsl:text>&amp;search=</xsl:text>
								<xsl:value-of select="/root/search" />
							</xsl:if>
						</xsl:attribute>
						<xsl:value-of select="data" />
					</a>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>	
		<hr />
	</xsl:template>
</xsl:stylesheet>