<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output  
	method="xml"
	doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" 
	doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"
	indent="yes" />
	<xsl:template match="/">
		<hr />
		<h2>
			<xsl:value-of select="/root/lang/h2_player" />
		</h2>
		<i>
			<xsl:value-of select="/root/lang/player_stats" />
		</i>
		<b>
			<xsl:value-of select="/root/player/nick" />
		</b>
		<hr />
		<div>
			<div style="float:left">
				<table class="no_aligin">
					<tr>
						<td>
							<xsl:value-of select="/root/lang/total_ammo" />
						</td>
						<td>
							<xsl:value-of select="/root/player/total_ammo" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/ammo" />
						</td>
						<td>
							<xsl:value-of select="/root/player/ammo" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/total_damage" />
						</td>
						<td>
							<xsl:value-of select="/root/player/total_damage" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/infect" />
						</td>
						<td>
							<xsl:value-of select="/root/player/infect" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/zombiekills" />
						</td>
						<td>
							<xsl:value-of select="/root/player/zombiekills" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/humankills" />
						</td>
						<td>
							<xsl:value-of select="/root/player/humankills" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/nemkills" />
						</td>
						<td>
							<xsl:value-of select="/root/player/nemkills" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/survkills" />
						</td>
						<td>
							<xsl:value-of select="/root/player/survkills" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/suicide" />
						</td>
						<td>
							<xsl:value-of select="/root/player/suicide" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/death" />
						</td>
						<td>
							<xsl:value-of select="/root/player/death" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/infected" />
						</td>
						<td>
							<xsl:value-of select="/root/player/infected" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/first_zombie" />
						</td>
						<td>
							<xsl:value-of select="/root/player/first_zombie" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/nemesis" />
						</td>
						<td>
							<xsl:value-of select="/root/player/nemesis" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/survivor" />
						</td>
						<td>
							<xsl:value-of select="/root/player/survivor" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/online" />
						</td>
						<td>
							<xsl:value-of select="/root/player/online" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/last_game" />
						</td>
						<td>
							<xsl:value-of select="/root/player/last_game" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/last_class" />
						</td>
						<td>
							<a>
								<xsl:attribute name="href">
									<xsl:text>
										index.php?action=classes&amp;id=
									</xsl:text>
									<xsl:value-of select="/root/player/class" />
								</xsl:attribute>
								<xsl:value-of select="/root/player/name" />
							</a>
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/ip" />
						</td>
						<td>
							<xsl:value-of select="/root/player/ip" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/steam_id" />
						</td>
						<td>
							<xsl:value-of select="/root/player/steam_id" />
						</td>
					</tr>
				</table>
			</div>
			<div>
				<table>
					<tr>
						<td>
							<a>
								<xsl:attribute name="href">
									<xsl:text>index.php?action=player&amp;sort=0&amp;id=</xsl:text>
									<xsl:value-of select="/root/player/id"/>
								</xsl:attribute>
								<xsl:value-of select="/root/lang/weapon" />
							</a>								
						</td>
						<td>
							<a>
								<xsl:attribute name="href">
									<xsl:text>index.php?action=player&amp;sort=1&amp;id=</xsl:text>
									<xsl:value-of select="/root/player/id"/>
								</xsl:attribute>
								<xsl:value-of select="/root/lang/kills" />
							</a>		
						</td>
						<td>
							<a>
								<xsl:attribute name="href">
									<xsl:text>index.php?action=player&amp;sort=2&amp;id=</xsl:text>
									<xsl:value-of select="/root/player/id"/>
								</xsl:attribute>
								<xsl:value-of select="/root/lang/shoot" />
							</a>		
						</td>
						<td>
							<a>
								<xsl:attribute name="href">
									<xsl:text>index.php?action=player&amp;sort=3&amp;id=</xsl:text>
									<xsl:value-of select="/root/player/id"/>
								</xsl:attribute>
								<xsl:value-of select="/root/lang/hit_head" />
							</a>	
						</td>
						<td>
							<a>
								<xsl:attribute name="href">
									<xsl:text>index.php?action=player&amp;sort=4&amp;id=</xsl:text>
									<xsl:value-of select="/root/player/id"/>
								</xsl:attribute>
								<xsl:value-of select="/root/lang/hit_chest" />
							</a>	
						</td>
						<td>
							<a>
								<xsl:attribute name="href">
									<xsl:text>index.php?action=player&amp;sort=5&amp;id=</xsl:text>
									<xsl:value-of select="/root/player/id"/>
								</xsl:attribute>
								<xsl:value-of select="/root/lang/hit_stomach" />
							</a>	
						</td>
						<td>
							<a>
								<xsl:attribute name="href">
									<xsl:text>index.php?action=player&amp;sort=6&amp;id=</xsl:text>
									<xsl:value-of select="/root/player/id"/>
								</xsl:attribute>
								<xsl:value-of select="/root/lang/hit_leftarm" />
							</a>	
						</td>
						<td>
							<a>
								<xsl:attribute name="href">
									<xsl:text>index.php?action=player&amp;sort=7&amp;id=</xsl:text>
									<xsl:value-of select="/root/player/id"/>
								</xsl:attribute>
								<xsl:value-of select="/root/lang/hit_rightarm" />
							</a>	
						</td>
						<td>
							<a>
								<xsl:attribute name="href">
									<xsl:text>index.php?action=player&amp;sort=8&amp;id=</xsl:text>
									<xsl:value-of select="/root/player/id"/>
								</xsl:attribute>
								<xsl:value-of select="/root/lang/hit_leftleg" />
							</a>	
						</td>
						<td>
							<a>
								<xsl:attribute name="href">
									<xsl:text>index.php?action=player&amp;sort=8&amp;id=</xsl:text>
									<xsl:value-of select="/root/player/id"/>
								</xsl:attribute>
								<xsl:value-of select="/root/lang/hit_rightleg" />
							</a>	
						</td>
						<td>
							<a>
								<xsl:attribute name="href">
									<xsl:text>index.php?action=player&amp;sort=9&amp;id=</xsl:text>
									<xsl:value-of select="/root/player/id"/>
								</xsl:attribute>
								<xsl:value-of select="/root/lang/acc" />
							</a>	
						</td>
					</tr>
					<xsl:for-each select="/root/weapons/weapon">
						<tr>
							<td class="td_left">
								<a>
									<xsl:attribute name="href">
										<xsl:text>index.php?action=weapons&amp;id=</xsl:text>
										<xsl:value-of select="id_weapon"/>
									</xsl:attribute>
									<xsl:value-of select="name" />
								</a>
							</td>
							<td>
								<xsl:value-of select="kills" />
							</td>
							<td>
								<xsl:value-of select="shoot" />
							</td>
							<td>
								<xsl:value-of select="hit_head" />
							</td>
							<td>
								<xsl:value-of select="hit_chest" />
							</td>
							<td>
								<xsl:value-of select="hit_stomach" />
							</td>
							<td>
								<xsl:value-of select="hit_leftarm" />
							</td>
							<td>
								<xsl:value-of select="hit_rightarm" />
							</td>
							<td>
								<xsl:value-of select="hit_leftleg" />
							</td>
							<td>
								<xsl:value-of select="hit_rightleg" />
							</td>
							<td>
								<xsl:value-of select="acc" />
							</td>
						</tr>
					</xsl:for-each>
				</table>				
			</div>
			<hr />
			<div>
				<table>
					<tr>
						<td>
							<a>
								<xsl:attribute name="href">
									<xsl:text>index.php?action=player&amp;csort=0&amp;id=</xsl:text>
									<xsl:value-of select="/root/player/id"/>
								</xsl:attribute>
								<xsl:value-of select="/root/lang/class" />
							</a>								
						</td>
						<td>
							<a>
								<xsl:attribute name="href">
									<xsl:text>index.php?action=player&amp;csort=1&amp;id=</xsl:text>
									<xsl:value-of select="/root/player/id"/>
								</xsl:attribute>
								<xsl:value-of select="/root/lang/infect" />
							</a>		
						</td>
						<td>
							<a>
								<xsl:attribute name="href">
									<xsl:text>index.php?action=player&amp;csort=2&amp;id=</xsl:text>
									<xsl:value-of select="/root/player/id"/>
								</xsl:attribute>
								<xsl:value-of select="/root/lang/kills" />
							</a>		
						</td>
						<td>
							<a>
								<xsl:attribute name="href">
									<xsl:text>index.php?action=player&amp;csort=3&amp;id=</xsl:text>
									<xsl:value-of select="/root/player/id"/>
								</xsl:attribute>
								<xsl:value-of select="/root/lang/death" />
							</a>	
						</td>
					</tr>
					<xsl:for-each select="/root/classes/class">
						<tr>
							<td class="td_left">
								<a>
									<xsl:attribute name="href">
										<xsl:text>index.php?action=classes&amp;id=</xsl:text>
										<xsl:value-of select="id"/>
									</xsl:attribute>
									<xsl:value-of select="name" />
								</a>
							</td>
							<td>
								<xsl:value-of select="infect" />
							</td>
							<td>
								<xsl:value-of select="kills" />
							</td>
							<td>
								<xsl:value-of select="death" />
							</td>
						</tr>
					</xsl:for-each>
				</table>				
			</div>
		</div>
		<hr />
	</xsl:template>
</xsl:stylesheet>