<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output  
	method="xml"
	doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" 
	doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"
	indent="yes" />
	<xsl:template match="/">
		<hr />
		<h2>
			<xsl:value-of select="/root/lang/h2_weapons" />
		</h2>
		<hr />
		<div>
			<div style="float:left; margin-right:10px">
				<img>
					<xsl:attribute name="src">
						<xsl:text>img/weapons/</xsl:text>
						<xsl:value-of select="/root/weapon/name" />
						<xsl:text>.gif</xsl:text>	
					</xsl:attribute>
				</img>
				<table class="no_aligin">
					<tr>
						<td>
							<xsl:value-of select="/root/lang/weapon" />
						</td>
						<td>
							<xsl:value-of select="/root/weapon/name" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/kills" />
						</td>
						<td>
							<xsl:value-of select="/root/weapon/kills" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/shoot" />
						</td>
						<td>
							<xsl:value-of select="/root/weapon/shoot" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/hit_head" />
						</td>
						<td>
							<xsl:value-of select="/root/weapon/hit_head" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/hit_chest" />
						</td>
						<td>
							<xsl:value-of select="/root/weapon/hit_chest" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/hit_stomach" />
						</td>
						<td>
							<xsl:value-of select="/root/weapon/hit_stomach" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/hit_leftarm" />
						</td>
						<td>
							<xsl:value-of select="/root/weapon/hit_leftarm" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/hit_rightarm" />
						</td>
						<td>
							<xsl:value-of select="/root/weapon/hit_rightarm" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/hit_leftleg" />
						</td>
						<td>
							<xsl:value-of select="/root/weapon/hit_leftleg" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/hit_rightleg" />
						</td>
						<td>
							<xsl:value-of select="/root/weapon/hit_rightleg" />
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/acc" />
						</td>
						<td>
							<xsl:value-of select="/root/weapon/acc" />
						</td>
					</tr>
				</table>
			</div>	
			<div>
				<b>
					<xsl:value-of select="/root/lang/best_players" />
				</b>
				<table>
					<tr>
						<td>
							<xsl:value-of select="/root/lang/name" />
						</td>
						<td>
							<xsl:value-of select="/root/lang/kills" />
						</td>
					</tr>
					<xsl:for-each select="/root/players/player">
						<tr>
							<td class="td_left">
								<a>
									<xsl:attribute name="href">
										<xsl:text>index.php?action=player&amp;id=</xsl:text>
										<xsl:value-of select="id"/>
									</xsl:attribute>
									<xsl:value-of select="nick" />
								</a>
							</td>
							<td>
								<xsl:value-of select="kills" />
							</td>
						</tr>
					</xsl:for-each>
				</table>
			</div>	
		</div>
		<hr />
	</xsl:template>
</xsl:stylesheet>